"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var RX = require("reactxp");
// import * as React from 'react';
// import Keybinder from '../appUtilities/Keybinder'
var fingerCounter_1 = require("./fingerCounter/fingerCounter");
var styles = {
    row: RX.Styles.createViewStyle({
        flexDirection: 'row',
        backgroundColor: "white",
    }, false)
};
var keys = [
    [7, 8, 9],
    [4, 5, 6],
    [1, 2, 3],
    [0]
];
var highlights = [
    [0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
    [1, 2, 3, 4, 5, 6, 7, 8, 9, 0],
    [2, 4, 6, 8, 0, 2, 4, 6, 8, 0],
    [3, 6, 9, 2, 5, 8, 1, 4, 7, 0],
    [4, 8, 2, 6, 0, 4, 8, 2, 6, 0],
    [5, 0, 5, 0, 5, 0, 5, 0, 5, 0],
    [6, 2, 8, 4, 0, 6, 2, 8, 4, 0],
    [7, 4, 1, 8, 5, 2, 9, 6, 3, 0],
    [8, 6, 4, 2, 0, 8, 6, 4, 2, 0],
    [9, 8, 7, 6, 5, 4, 3, 2, 1, 0],
    [0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
];
var Numpad = (function (_super) {
    __extends(Numpad, _super);
    // private UIbindings: Keybinder;
    function Numpad(props) {
        var _this = _super.call(this) || this;
        // this.UIbindings = new Keybinder([
        //     {
        //         binding: 'left',
        //         callback: (e) => {
        //             this.setState({
        //                 counted: Math.max(0, (this.state.counted - 1))
        //             })
        //         }
        //     },
        //     {
        //         binding: 'right',
        //         callback: (e) => {
        //             this.setState({
        //                 counted: Math.min(10, (this.state.counted + 1))
        //             });
        //         }
        //     }
        // ])
        _this.state = {
            counted: 0
        };
        return _this;
    }
    Numpad.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        if (nextProps) {
            this.setState({
                counted: 0
            });
        }
        return true;
    };
    Numpad.prototype.componentDidMount = function () {
        // this.UIbindings.bind();
    };
    Numpad.prototype.componentWillUnmount = function () {
        // this.UIbindings.unbind();
    };
    Numpad.prototype.render = function () {
        var _this = this;
        var num = this.props.num;
        var counted = this.state.counted;
        return (RX.createElement(RX.View, null,
            RX.createElement("div", null, keys.map(function (keyrow, index) {
                return _this.renderKeyRow(keyrow, index);
            })),
            RX.createElement(fingerCounter_1.default, { counted: counted })));
    };
    Numpad.prototype.renderKeyRow = function (keys, index) {
        var _this = this;
        var style = RX.Styles.createViewStyle({
            flexDirection: "row",
        }, false);
        return (RX.createElement(RX.View, { style: style, key: index }, keys.map(function (key, index) {
            return _this.renderKey(key, index);
        })));
    };
    Numpad.prototype.renderKey = function (key, index) {
        return (RX.createElement(RX.Text, { style: this.getKeyStyle(key), key: index },
            " ",
            key,
            " "));
    };
    Numpad.prototype.getKeyStyle = function (key) {
        return RX.Styles.createTextStyle({
            borderStyle: "solid",
            borderColor: "black",
            borderWidth: 1,
            borderRadius: 4,
            padding: 4,
            margin: 3,
            backgroundColor: this.getBackgroundColor(key)
        }, false);
    };
    Numpad.prototype.getBackgroundColor = function (key) {
        if (highlights[this.props.num][this.state.counted - 1] == key) {
            return 'green';
        }
        return 'white';
    };
    return Numpad;
}(RX.Component));
exports.default = Numpad;
//# sourceMappingURL=numpad.js.map