"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var RX = require("reactxp");
var Recorder_1 = require("../appUtilities/Recorder");
var styles = {
    correct: RX.Styles.createTextStyle({
        backgroundColor: "green"
    }),
    incorrect: RX.Styles.createTextStyle({
        backgroundColor: 'purple'
    })
};
var SessionReport = (function (_super) {
    __extends(SessionReport, _super);
    function SessionReport(props) {
        return _super.call(this, props) || this;
    }
    SessionReport.prototype.getSessionQuestions = function (records) {
        var sessionRecords = new Array();
        var correctCount = 0;
        var index = records.length - 1;
        while (correctCount < 25) {
            if (records[index].correct) {
                correctCount++;
            }
            index--;
        }
        return records.slice(Math.max(0, index), records.length);
    };
    SessionReport.prototype.render = function () {
        var _this = this;
        var records = Recorder_1.default.getRecord();
        var truncatedRecords = this.getSessionQuestions(records);
        console.log("Rendering a session report...");
        var time = 0;
        truncatedRecords.forEach(function (record) {
            time += record.time;
        });
        time = parseInt(time.toFixed(0));
        return (RX.createElement(RX.View, null,
            RX.createElement("ul", null, truncatedRecords.map(function (record, index) {
                return (RX.createElement("li", { key: index }, _this.renderRecord(record)));
            })),
            (truncatedRecords.length <= 28) ?
                RX.createElement(RX.Text, null,
                    "It took ",
                    time,
                    " seconds to do these! Can you beat this?") :
                null,
            RX.createElement("button", { autoFocus: true, onClick: function () { window.location.reload(); } }, "Try again!")));
    };
    SessionReport.prototype.renderRecord = function (record) {
        if (record.q === 'multiplication') {
            return (RX.createElement(RX.Text, { style: record.correct ? styles.correct : styles.incorrect },
                record.a,
                " \u00D7 ",
                record.b,
                " = ",
                record.answer,
                "   (in ",
                record.time,
                " s)"));
        }
        else {
            return (RX.createElement(RX.Text, { style: record.correct ? styles.correct : styles.incorrect },
                record.a * record.b,
                " \u00F7 ",
                record.b,
                " = ",
                record.answer,
                "   (in ",
                record.time,
                " s)"));
        }
    };
    return SessionReport;
}(RX.Component));
exports.default = SessionReport;
//# sourceMappingURL=sessionReport.js.map